using System;
using System.Collections.Generic;
using System.Data;
using System.Text;

namespace CustomGridCell
{
    class Product
    {
        public string ProductName;
        public string ProductDescription;
        public List<Product> childProducts = new List<Product>();

        public Product()
        {
            ProductName = string.Empty;
            ProductDescription = string.Empty;

        }
        public static Product GetProductHierarchy(int productId)
        {
            // Adding data manually to the datatable
            DataTable productTable = new DataTable();
            productTable.Columns.Add("PRODUCT_NAME");
            productTable.Columns.Add("PRODUCT_DESC");
            productTable.Columns.Add("PARENT_ID");

            // FILL THE DATATABLE 

            Product productHierarchy = new Product();
            DataRow[] row = new DataRow[10];

            for (int i = 0; i < 10; i++)
            {
                row[i] = productTable.NewRow();
                row[i]["PRODUCT_NAME"] = "Product "     + (i + 1).ToString();
                row[i]["PRODUCT_DESC"] = "Description " + (i + 1).ToString();

                if (i == 0)
                {
                    row[i]["PARENT_ID"] = 0;
                }
                else
                {
                    row[i]["PARENT_ID"] = 1;
                }

                productTable.Rows.Add(row[i]);
            }

            int j = 0; 
            foreach (DataRow dataRow in productTable.Rows)
            {
                if (j == 0)
                {
                    productHierarchy.ProductName = dataRow["PRODUCT_NAME"].ToString();
                    productHierarchy.ProductDescription = dataRow["PRODUCT_DESC"].ToString();
                }
                else
                {
                    Product childProduct = new Product();
                    childProduct.ProductDescription = dataRow["PRODUCT_DESC"].ToString();
                    childProduct.ProductName = dataRow["PRODUCT_NAME"].ToString();

                    productHierarchy.childProducts.Add(childProduct);
                }
                j++;
            }
            return productHierarchy;
        }

    }
}
