#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

namespace CustomGridCell
{
	using System;
	using System.Drawing;
	using System.Collections;
    using System.Collections.Specialized;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;
    using System.Data.SqlClient;
	using Syncfusion.Windows.Forms.Grid;
	using System.Runtime.Serialization;
	using System.Runtime.Serialization.Formatters.Binary;
	using System.IO;

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class TreeGridForm : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;

		static public int NoChildBMP;
		static public int OpenedBMP;
		static public int ClosedBMP;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Panel panel1;


		//sample data members...
		public static CollapsibleDataSource externalData;

        static public int numberRowsPerRecord = 2;
        DataSet ds;
        StringCollection myItems = new StringCollection();
		public TreeGridForm()
		{
			NoChildBMP = 2;
			OpenedBMP = 0;
			ClosedBMP = 1;
			
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			gridControl1.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.button3 = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.button4 = new System.Windows.Forms.Button();
            this.button5 = new System.Windows.Forms.Button();
            this.panel1 = new System.Windows.Forms.Panel();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.gridControl1.HorizontalThumbTrack = true;
            this.gridControl1.Location = new System.Drawing.Point(40, 72);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.Size = new System.Drawing.Size(870, 280);
            this.gridControl1.SmartSizeBox = false;
            this.gridControl1.TabIndex = 0;
            this.gridControl1.Text = "gridControl1";
            this.gridControl1.ThemesEnabled = true;
            this.gridControl1.VerticalThumbTrack = true;
            // 
            // imageList1
            // 
            this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
            this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            // 
            // button1
            // 
            this.button1.Anchor = System.Windows.Forms.AnchorStyles.Top;
            this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button1.Location = new System.Drawing.Point(323, 46);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(104, 23);
            this.button1.TabIndex = 1;
            this.button1.Text = "LoadDataSource";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.Anchor = System.Windows.Forms.AnchorStyles.Top;
            this.button2.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button2.Location = new System.Drawing.Point(435, 46);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(112, 23);
            this.button2.TabIndex = 2;
            this.button2.Text = "SaveDataSource";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // button3
            // 
            this.button3.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button3.Location = new System.Drawing.Point(40, 46);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(80, 23);
            this.button3.TabIndex = 3;
            this.button3.Text = "Reset";
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // label1
            // 
            this.label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(222)))), ((int)(((byte)(100)))), ((int)(((byte)(19)))));
            this.label1.Location = new System.Drawing.Point(43, 25);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(510, 16);
            this.label1.TabIndex = 4;
            this.label1.Text = "Right-click the node in column A to indent / outdent";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // button4
            // 
            this.button4.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button4.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button4.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button4.Location = new System.Drawing.Point(743, 46);
            this.button4.Name = "button4";
            this.button4.Size = new System.Drawing.Size(80, 23);
            this.button4.TabIndex = 5;
            this.button4.Text = "ExpandAll";
            this.button4.Click += new System.EventHandler(this.button4_Click);
            // 
            // button5
            // 
            this.button5.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button5.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button5.Location = new System.Drawing.Point(829, 46);
            this.button5.Name = "button5";
            this.button5.Size = new System.Drawing.Size(80, 23);
            this.button5.TabIndex = 6;
            this.button5.Text = "CloseAll";
            this.button5.Click += new System.EventHandler(this.button5_Click);
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Controls.Add(this.button5);
            this.panel1.Controls.Add(this.button4);
            this.panel1.Controls.Add(this.button2);
            this.panel1.Controls.Add(this.button1);
            this.panel1.Controls.Add(this.button3);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(950, 382);
            this.panel1.TabIndex = 7;
            // 
            // TreeGridForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
            this.ClientSize = new System.Drawing.Size(950, 382);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.gridControl1);
            this.Controls.Add(this.panel1);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Name = "TreeGridForm";
            this.Text = "Virtual TreeGrid...";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
# if SyncfusionFramework1_1 || SyncfusionFramework2_0  
			Application.EnableVisualStyles();
# endif
			Application.Run(new TreeGridForm());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// load the bitmaps
			this.imageList1.ImageSize = new Size(20, 34);
			Bitmap bm = new Bitmap(GetType().Module.Assembly.GetManifestResourceStream("CustomGridCell.minus.bmp"));
			this.imageList1.Images.Add(bm, Color.White);
			bm = new Bitmap(GetType().Module.Assembly.GetManifestResourceStream("CustomGridCell.plus.bmp"));
			this.imageList1.Images.Add(bm, Color.White);
			bm = new Bitmap(GetType().Module.Assembly.GetManifestResourceStream("CustomGridCell.nochild.bmp"));
			this.imageList1.Images.Add(bm, Color.White);

//			order read
//			static public int OpenedBMP = 0;
//			static public int ClosedBMP = 1;
//			static public int NoChildBMP = 2;

            //create a sample data for a virtual grid
            externalData = new CollapsibleDataSource(100);

			//add a custom cell control
			gridControl1.CellModels.Add("TreeCell", new TreeCellModel(gridControl1.Model));

			//make the imagelist available thru the tablestyle
			gridControl1.TableStyle.ImageList = this.imageList1;

			//create a sample data for a virtual grid
            //externalData = new CollapsibleDataSource(100);
            //externalData.InitData(); //initializes an external datasource
            //externalData.CollapseData(); // c

           
            // TODO - I want to use this object insted of dataset. 
            Product objProduct = Product.GetProductHierarchy(1);
            foreach (Product item in objProduct.childProducts)
            {
                MessageBox.Show(item.ProductName);
                MessageBox.Show(item.ProductDescription);
            }

            // use this object to bind to the grid. 

            //create a sample dbata for a virtual grid
            DataTable parentTable = GetParentTable();
            DataTable childTable = GetChildTable();
            DataTable grandChildTable = GetGrandChildTable();

            ds = new DataSet();
            ds.Tables.AddRange(new DataTable[] { parentTable, childTable, grandChildTable });

            myItems.AddRange(new string[] { "item1", "item2", "item3", "item4", "item5", "item6" });


			//hook up the events needed for virtual grid
			gridControl1.ResetVolatileData();
			gridControl1.QueryCellInfo += new GridQueryCellInfoEventHandler(GridQueryCellInfo);
			gridControl1.QueryRowCount += new GridRowColCountEventHandler(GridQueryRowCount);
			gridControl1.QueryColCount += new GridRowColCountEventHandler(GridQueryColCount);
			gridControl1.QueryColWidth += new GridRowColSizeEventHandler(GridQueryColWidth);

            gridControl1.QueryCoveredRange += new GridQueryCoveredRangeEventHandler(gridControl1_QueryCoveredRange);
            gridControl1.TopRowChanged += new GridRowColIndexChangedEventHandler(gridControl1_TopRowChanged);
            gridControl1.TopRowChanging += new GridRowColIndexChangingEventHandler(gridControl1_TopRowChanging);
			
			//handle saving data back to the data source...
			gridControl1.SaveCellInfo += new GridSaveCellInfoEventHandler(GridSaveCellInfo);


			//load a sample file...
            //ReadData(FindFullPath("datasample.cds"));

            gridControl1.ResetVolatileData();
            externalData.InitFromDataSet(ds);
            externalData.CollapseData(); // c
            gridControl1.Refresh();
			System.Drawing.Icon ico = new System.Drawing.Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"));
			this.Icon = ico ;
			this.gridControl1.DefaultRowHeight = 18;
			this.gridControl1.DefaultColWidth = 70;			
			this.gridControl1.Properties.GridLineColor = System.Drawing.Color.Silver;
			this.gridControl1.DefaultGridBorderStyle = GridBorderStyle.Solid;
		}

        int oldTopRow = -1;
        int targetRow = -1;
        void gridControl1_TopRowChanging(object sender, GridRowColIndexChangingEventArgs e)
        {
            oldTopRow = this.gridControl1.TopRowIndex;
            targetRow = e.Value;
        }

        private bool inAdjust = false;
        void gridControl1_TopRowChanged(object sender, GridRowColIndexChangedEventArgs e)
        {
            if (!inAdjust)
            {
                inAdjust = true;
                if (this.gridControl1.TopRowIndex % numberRowsPerRecord == 0)
                {
                    if (oldTopRow > targetRow)
                        this.gridControl1.TopRowIndex = targetRow - 1;
                    else
                        this.gridControl1.TopRowIndex = targetRow + 1;
                }

                inAdjust = false;

                //this.gridControl1.RefreshRange(GridRangeInfo.Col(1));
            }

        }

        void gridControl1_QueryCoveredRange(object sender, GridQueryCoveredRangeEventArgs e)
        {
            if (e.ColIndex == 1 && e.RowIndex > 0 && numberRowsPerRecord > 0)
            {
                int top = 1 + (e.RowIndex / numberRowsPerRecord) * numberRowsPerRecord;
                int bot = top + numberRowsPerRecord - 1;
                e.Range = GridRangeInfo.Cells(top, 1, bot, 1);
                e.Handled = true;
            }
        }

		string FindFullPath(string cdsFileName)
		{
			// Check both in parent folder and Parent\Data folders.
			string cdsDataFileName = @"Data\" + cdsFileName;
			for (int n = 0; n < 10; n++)
			{
				if (System.IO.File.Exists(cdsFileName))
				{
					return Path.GetFullPath(cdsFileName);
				}
				if (System.IO.File.Exists(cdsDataFileName))
				{
					return Path.GetFullPath(cdsDataFileName);
				}
				cdsFileName = @"..\" + cdsFileName;
				cdsDataFileName = @"..\" + cdsDataFileName;
			}

			return "";
		}


		void GridSaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			try
			{
				//move the changes back to the external data object
                int row = (e.RowIndex - 1) / numberRowsPerRecord;
					
				if(e.ColIndex == 1 && e.RowIndex > 0)
				{
                   //externalData[e.RowIndex - 1].ExpandState = (TreeNodeState) e.Style.ImageIndex;
					externalData[row].ExpandState = (int) e.Style.ImageIndex;
					externalData[row].IndentLevel = (int) e.Style.Tag;
				}

				if( e.ColIndex > 0 && e.RowIndex > 0)
				{
					externalData[row].Items[e.ColIndex - 1] = (string) e.Style.CellValue;

				}
			}
			catch{}

			//refresh this row so change is displayed
			if(!externalData.Locked)
			{
				externalData.CollapseData();
				this.gridControl1.Refresh();
			}
			e.Handled = true;
		}

		void GridQueryColWidth(object sender, GridRowColSizeEventArgs e) 
		{
			if( e.Index == 1)
				e.Size = 200;
			else if (e.Index > 0)
				e.Size = 100;
			else
				e.Size = 0;//hide the side header // 30;

			e.Handled = true;
		}
		void GridQueryRowCount(object sender, GridRowColCountEventArgs e) 
		{
            e.Count = numberRowsPerRecord * externalData.RowCount;
			e.Handled = true;
		}

		void GridQueryColCount(object sender, GridRowColCountEventArgs e) 
		{
			//e.Count =  externalData.ColCount / numberRowsPerRecord + 1;
            e.Count = externalData.ColCount;
			e.Handled = true;
		}

		void GridQueryCellInfo(object sender, GridQueryCellInfoEventArgs e) 
		{
			if (e.RowIndex > 0 && e.ColIndex > 0)
			{
                int rowIndex = (e.RowIndex-1) / numberRowsPerRecord;
                if(e.RowIndex == 1 && e.ColIndex > 1)
                {
                    e.Style.CellType = "TreeCell";
                    e.Style.Tag = "Week" + string.Empty + e.ColIndex.ToString();
                }
                else if (e.RowIndex % numberRowsPerRecord == 1 || numberRowsPerRecord == 1)
                {

                    e.Style.CellValue = externalData[rowIndex].Items[e.ColIndex - 1];
                    if (e.ColIndex == 1)
                    {
                        e.Style.CellType = "TreeCell";
                        e.Style.Tag = externalData[rowIndex].IndentLevel;
                        e.Style.ImageIndex = (int)externalData[rowIndex].ExpandState;
                        //					e.Style.Borders.BeginUpdate();
                        //					e.Style.Borders.Left = new GridBorder(GridBorderStyle.None);
                        //					e.Style.Borders.Top = new GridBorder(GridBorderStyle.None);
                        //					e.Style.Borders.Bottom = new GridBorder(GridBorderStyle.None);
                        //					e.Style.Borders.EndUpdate();
                    }
                }
                else
                {
                    int col = externalData.ColCount / numberRowsPerRecord + e.ColIndex - 1; 
                    if (e.RowIndex % numberRowsPerRecord == 0 && numberRowsPerRecord > 1
                        && col < externalData.ColCount)
                    {
                        e.Style.CellValue = externalData[rowIndex].Items[col];
                    }
                }
				e.Handled = true;
			}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			// Create a SaveFileDialog 
			SaveFileDialog saveFile1 = new SaveFileDialog();
			saveFile1.DefaultExt = "*.cds";
			saveFile1.Filter = "Collapsible Data Files|*.cds";
			saveFile1.InitialDirectory = Application.ExecutablePath;

			// get a file name from the user
			if(saveFile1.ShowDialog() == DialogResult.OK)
			{
				IFormatter formatter = new BinaryFormatter();
				Stream stream = new FileStream(saveFile1.FileName, FileMode.Create, FileAccess.Write, FileShare.None);
				formatter.Serialize(stream, externalData);
				stream.Close();
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog openFileDialog1 = new OpenFileDialog();

			openFileDialog1.Filter = "Collapsible Data Files|*.cds";
			openFileDialog1.FilterIndex = 1 ;
			openFileDialog1.InitialDirectory = Application.ExecutablePath;

			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				ReadData(openFileDialog1.FileName);
			}
		}

		private void ReadData(string fileName)
		{
			try
			{
                //IFormatter formatter = new BinaryFormatter();
                //Stream stream = new FileStream(fileName, FileMode.Open, FileAccess.Read, FileShare.Read);
                //externalData = (CollapsibleDataSource) formatter.Deserialize(stream);
                //stream.Close();

                //gridControl1.ResetVolatileData();
                //externalData.CollapseData();
                //this.gridControl1.Refresh();
			}
			catch{}
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			gridControl1.ResetVolatileData();
			externalData.InitData();
			externalData.CollapseData();
			this.gridControl1.Refresh();
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			gridControl1.ResetVolatileData();
			externalData.ExpandAll();
			externalData.CollapseData();
			gridControl1.UpdateScrollBars();
			this.gridControl1.Invalidate();
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			gridControl1.ResetVolatileData();
			externalData.CloseAll();
			externalData.CollapseData();
			gridControl1.CurrentCell.MoveTo(1,1);
			gridControl1.UpdateScrollBars();
			this.gridControl1.Invalidate();
        }


        #region DataTables
        private int numberParentRows = 5;
        private int numberChildRows = 20;
        private int numberGrandChildRows = 50;
        private DataTable GetParentTable()
        {
            DataTable dt = new DataTable("ParentTable");
            dt.Columns.Add(new DataColumn("Month"));
            dt.Columns.Add(new DataColumn("Week1"));
            dt.Columns.Add(new DataColumn("Week2"));
            dt.Columns.Add(new DataColumn("Week3"));
            dt.Columns.Add(new DataColumn("Week5"));

            for (int i = 0; i < numberParentRows; ++i)
            {
                DataRow dr = dt.NewRow();
                dr[0] = 4000;
                dr[1] = 40;
                dr[2] = 60;
                dr[3] = 25;
                dr[4] = 75;
                dt.Rows.Add(dr);
            }

            return dt;
        }

        private DataTable GetChildTable()
        {
            DataTable dt = new DataTable("ChildTable");

            dt.Columns.Add(new DataColumn("Month"));
            dt.Columns.Add(new DataColumn("Week1"));
            dt.Columns.Add(new DataColumn("Week2"));
            dt.Columns.Add(new DataColumn("Week3"));
            dt.Columns.Add(new DataColumn("Week5"));

            for (int i = 0; i < numberChildRows; ++i)
            {
                DataRow dr = dt.NewRow();
                dr[0] = 4000;
                dr[1] = 40;
                dr[2] = 60;
                dr[3] = 25;
                dr[4] = 75;
                dt.Rows.Add(dr);
            }

            return dt;
        }

        private DataTable GetGrandChildTable()
        {
            DataTable dt = new DataTable("GrandChildTable");
            dt.Columns.Add(new DataColumn("Month"));
            dt.Columns.Add(new DataColumn("Week1"));
            dt.Columns.Add(new DataColumn("Week2"));
            dt.Columns.Add(new DataColumn("Week3"));
            dt.Columns.Add(new DataColumn("Week5"));

            for (int i = 0; i < numberGrandChildRows; ++i)
            {
                DataRow dr = dt.NewRow();
                dr[0] = 4000;
                dr[1] = 40;
                dr[2] = 60;
                dr[3] = 25;
                dr[4] = 75;
                dt.Rows.Add(dr);
            }

            return dt;
        }
        #endregion 
    }
}
